<template>
  <GList
    :rowComponent="rowComponent"
    :columns="columns"
    :loading="loading"
    :loadingMore="loadingMore"
    :resultList="resultList"
    :nbResults="nbResults"
    :hasMore="hasMore"
    :noResultMessage="noResultMessage"
    @loadMore="loadMore"
    @refresh="$emit('refresh')" />
</template>
  
<script>
  
import GList from "./GList.vue";

export default {
  name: "GLocalList",
  components: {
    GList,
  },
  props: {
    rowComponent: {
      type: [String, Object],
      required: true,
    },
    columns: {
      type: Array,
      required: false,
      default: null,
    },
    loadFuntion: {
      // Must be a function that accept two arguments limit and page and return a Promise
      type: Function,
      required: true,
    },
    noResultMessage: {
      type: String,
      required: false,
      default: "Aucun résultat à afficher",
    },
  },
  emits: ["refresh"],
  data() {
    return {
      loading: false,
      limit: 10,
      page: 1,
      resultList: null,
      nbResults: 0,
      loadingMore: false,
    };
  },
  computed: {
    hasMore() {
      return this.resultList != null && this.nbResults != null && this.nbResults > this.resultList.length;
    },
  },
  watch: {
    type() {
      this.initializeResultList();
    },
  },
  mounted() {
    this.initializeResultList();
  },
  methods: {
    initializeResultList() {
      // Refresh only if result list haven't been initialized yet

      if (this.resultList == null) {
        this.refreshResultList();
      }
    },
    refreshResultList() {
      // Force refresh of result list

      this.loading = true;
      this.page = 1;
      
      this.loadFuntion(this.limit, this.page)
        .then((response) => {
          this.resultList = response.data.results;
          this.nbResults = response.data.nb_results;
          this.loading = false;
        })
        .finally(() => {
          this.loading = false;
        });
    },
    loadMore() {
      this.loadingMore = true;
      this.error = false;
      this.page = this.page + 1;
  
      this.loadFuntion(this.limit, this.page)
        .then((response) => {
          this.resultList = this.resultList.concat(response.data.results);
          this.nbResults = response.data.nb_results;
          this.loadingMore = false;
        })
        .finally(() => {
          this.loadingMore = false;
        });
    },
  },
};
</script>
